/****************************************************************************
**
** Copyright (C) 1992-2006 Trolltech ASA. All rights reserved.
**
** This file is part of the QtGui module of the Qt Toolkit.
**
** Licensees holding valid Qt Preview licenses may use this file in
** accordance with the Qt Preview License Agreement provided with the
** Software.
**
** See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
** information about Qt Commercial License Agreements.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#ifndef QHIVIEWWIDGET_P_H
#define QHIVIEWWIDGET_P_H

#include <QtGui/qapplication.h>
#include <QtGui/qwidget.h>
#include <private/qt_mac_p.h>

//
//  W A R N I N G
//  -------------
//
// This file is not part of the Qt API.  It exists purely as an
// implementation detail.  This header file may change from version to
// version without notice, or even be removed.
//
// We mean it.
//

class QHIViewWidget : public QWidget
{
    Q_OBJECT
public:
    QHIViewWidget(WindowRef windowref, bool createSubs=true, QWidget *parent=0, Qt::WindowFlags flags = 0);
    QHIViewWidget(HIViewRef hiviewref, bool createSubs=true, QWidget *parent=0, Qt::WindowFlags flags = 0);
    ~QHIViewWidget();

private:
    void createQWidgetsFromHIViews();
    void addViews_recursive(HIViewRef child, QWidget *parent);
};

#endif // QHIVIEWWIDGET_P_H
